Main Page Modules Class Hierarchy Data Structures File List Data Fields Globals Related Pages

# OsclPriorityQueue< Qelem, Alloc, Container, Compare > Class Template Reference
[OSCL Util]

`#include <oscl_priqueue.h>`

Inheritance diagram for OsclPriorityQueue< Qelem, Alloc, Container, Compare >:

## Public Types
typedef Container::value_type | value_type
typedef Container | container_type
typedef Container::iterator | iterator
typedef Container::const_reference | const_reference
## Public Methods
bool | empty () const
uint32 | size () const
void | reserve (uint32 n)
const_reference | top () const
const Container & | vec ()
void | push (const value_type &input)
void | pop ()
int | remove (const value_type &input)
| OsclPriorityQueue ()
virtual | ~OsclPriorityQueue ()
## Protected Methods
void | push_heap (iterator first, iterator last)
void | pop_heap (iterator first, iterator last)
iterator | find_heap (const value_type &input, iterator first, iterator last)
int | validate ()
void | swap (OsclAny *dest, const OsclAny *src)
int | compare_LT (OsclAny *a, OsclAny *b) const
int | compare_EQ (const OsclAny *a, const OsclAny *b) const
## Protected Attributes
Container | c
Compare | comp
## Friends
class | oscl_priqueue_test

### template<class Qelem, class Alloc, class Container = Oscl_Vector<Qelem, Alloc>, class Compare = OsclCompareLess<Qelem>>
class OsclPriorityQueue< Qelem, Alloc, Container, Compare >

## Member Typedef Documentation

template<class Qelem, class Alloc, class Container = Oscl_Vector<Qelem, Alloc>, class Compare = OsclCompareLess<Qelem>>
typedef Container::const_reference OsclPriorityQueue< Qelem, Alloc, Container, Compare >::const_reference

template<class Qelem, class Alloc, class Container = Oscl_Vector<Qelem, Alloc>, class Compare = OsclCompareLess<Qelem>>
typedef Container OsclPriorityQueue< Qelem, Alloc, Container, Compare >::container_type

template<class Qelem, class Alloc, class Container = Oscl_Vector<Qelem, Alloc>, class Compare = OsclCompareLess<Qelem>>
typedef Container::iterator OsclPriorityQueue< Qelem, Alloc, Container, Compare >::iterator

template<class Qelem, class Alloc, class Container = Oscl_Vector<Qelem, Alloc>, class Compare = OsclCompareLess<Qelem>>
typedef Container::value_type OsclPriorityQueue< Qelem, Alloc, Container, Compare >::value_type

## Constructor & Destructor Documentation

template<class Qelem, class Alloc, class Container = Oscl_Vector<Qelem, Alloc>, class Compare = OsclCompareLess<Qelem>>
OsclPriorityQueue< Qelem, Alloc, Container, Compare >::OsclPriorityQueue | ( |  | ) | `[inline]`

template<class Qelem, class Alloc, class Container = Oscl_Vector<Qelem, Alloc>, class Compare = OsclCompareLess<Qelem>>
virtual OsclPriorityQueue< Qelem, Alloc, Container, Compare >::~OsclPriorityQueue | ( |  | ) | `[inline, virtual]`

## Member Function Documentation

template<class Qelem, class Alloc, class Container = Oscl_Vector<Qelem, Alloc>, class Compare = OsclCompareLess<Qelem>>
int OsclPriorityQueue< Qelem, Alloc, Container, Compare >::compare_EQ | ( | const OsclAny * | a,
|  | const OsclAny * | b
| ) | const`[inline, protected, virtual]`

| Return a==b. Implements Oscl_Opaque_Type_Compare.

template<class Qelem, class Alloc, class Container = Oscl_Vector<Qelem, Alloc>, class Compare = OsclCompareLess<Qelem>>
int OsclPriorityQueue< Qelem, Alloc, Container, Compare >::compare_LT | ( | OsclAny * | a,
|  | OsclAny * | b
| ) | const`[inline, protected, virtual]`

| Return a<b. Implements Oscl_Opaque_Type_Compare.

template<class Qelem, class Alloc, class Container = Oscl_Vector<Qelem, Alloc>, class Compare = OsclCompareLess<Qelem>>
bool OsclPriorityQueue< Qelem, Alloc, Container, Compare >::empty | ( |  | ) | const`[inline]`

template<class Qelem, class Alloc, class Container = Oscl_Vector<Qelem, Alloc>, class Compare = OsclCompareLess<Qelem>>
iterator OsclPriorityQueue< Qelem, Alloc, Container, Compare >::find_heap | ( | const value_type & | input,
|  | iterator | first,
|  | iterator | last
| ) | `[inline, protected]`

template<class Qelem, class Alloc, class Container = Oscl_Vector<Qelem, Alloc>, class Compare = OsclCompareLess<Qelem>>
void OsclPriorityQueue< Qelem, Alloc, Container, Compare >::pop | ( |  | ) | `[inline]`

template<class Qelem, class Alloc, class Container = Oscl_Vector<Qelem, Alloc>, class Compare = OsclCompareLess<Qelem>>
void OsclPriorityQueue< Qelem, Alloc, Container, Compare >::pop_heap | ( | iterator | first,
|  | iterator | last
| ) | `[inline, protected]`

template<class Qelem, class Alloc, class Container = Oscl_Vector<Qelem, Alloc>, class Compare = OsclCompareLess<Qelem>>
void OsclPriorityQueue< Qelem, Alloc, Container, Compare >::push | ( | const value_type & | input | ) | `[inline]`

template<class Qelem, class Alloc, class Container = Oscl_Vector<Qelem, Alloc>, class Compare = OsclCompareLess<Qelem>>
void OsclPriorityQueue< Qelem, Alloc, Container, Compare >::push_heap | ( | iterator | first,
|  | iterator | last
| ) | `[inline, protected]`

template<class Qelem, class Alloc, class Container = Oscl_Vector<Qelem, Alloc>, class Compare = OsclCompareLess<Qelem>>
int OsclPriorityQueue< Qelem, Alloc, Container, Compare >::remove | ( | const value_type & | input | ) | `[inline]`

template<class Qelem, class Alloc, class Container = Oscl_Vector<Qelem, Alloc>, class Compare = OsclCompareLess<Qelem>>
void OsclPriorityQueue< Qelem, Alloc, Container, Compare >::reserve | ( | uint32 | n | ) | `[inline]`

template<class Qelem, class Alloc, class Container = Oscl_Vector<Qelem, Alloc>, class Compare = OsclCompareLess<Qelem>>
uint32 OsclPriorityQueue< Qelem, Alloc, Container, Compare >::size | ( |  | ) | const`[inline]`

template<class Qelem, class Alloc, class Container = Oscl_Vector<Qelem, Alloc>, class Compare = OsclCompareLess<Qelem>>
void OsclPriorityQueue< Qelem, Alloc, Container, Compare >::swap | ( | OsclAny * | dest,
|  | const OsclAny * | src
| ) | `[inline, protected, virtual]`

| Swap element at "a" with element at "b". Both pointers must be non-NULL. Implements Oscl_Opaque_Type_Compare.

template<class Qelem, class Alloc, class Container = Oscl_Vector<Qelem, Alloc>, class Compare = OsclCompareLess<Qelem>>
const_reference OsclPriorityQueue< Qelem, Alloc, Container, Compare >::top | ( |  | ) | const`[inline]`

template<class Qelem, class Alloc, class Container = Oscl_Vector<Qelem, Alloc>, class Compare = OsclCompareLess<Qelem>>
int OsclPriorityQueue< Qelem, Alloc, Container, Compare >::validate | ( |  | ) | `[inline, protected]`

template<class Qelem, class Alloc, class Container = Oscl_Vector<Qelem, Alloc>, class Compare = OsclCompareLess<Qelem>>
const Container& OsclPriorityQueue< Qelem, Alloc, Container, Compare >::vec | ( |  | ) | `[inline]`

## Friends And Related Function Documentation

template<class Qelem, class Alloc, class Container = Oscl_Vector<Qelem, Alloc>, class Compare = OsclCompareLess<Qelem>>
friend class oscl_priqueue_test`[friend]`

## Field Documentation

template<class Qelem, class Alloc, class Container = Oscl_Vector<Qelem, Alloc>, class Compare = OsclCompareLess<Qelem>>
Container OsclPriorityQueue< Qelem, Alloc, Container, Compare >::c`[protected]`

template<class Qelem, class Alloc, class Container = Oscl_Vector<Qelem, Alloc>, class Compare = OsclCompareLess<Qelem>>
Compare OsclPriorityQueue< Qelem, Alloc, Container, Compare >::comp`[protected]`

The documentation for this class was generated from the following file:

- oscl_priqueue.h